/* -*- C -*- ***********************************************
Copyright 1991-1995 by Stichting Mathematisch Centrum, Amsterdam,
The Netherlands.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the names of Stichting Mathematisch
Centrum or CWI or Corporation for National Research Initiatives or
CNRI not be used in advertising or publicity pertaining to
distribution of the software without specific, written prior
permission.

While CWI is the initial source for this software, a modified version
is made available by the Corporation for National Research Initiatives
(CNRI) at the Internet address ftp://ftp.python.org.

STICHTING MATHEMATISCH CENTRUM AND CNRI DISCLAIM ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL STICHTING MATHEMATISCH
CENTRUM OR CNRI BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

******************************************************************/

/* Module configuration */

/* CONFIG.C -- 02-OCT-1996 Uwe Zessin */
/* 23-OCT-1997 ZE. -- add VMSDEF module
   19-NOV-1997 ZE. -- add PYVMS module
   29-NOV-1997 ZE. -- copy new Copyright from CONFIG.H_IN,
			add new modules from Python V1.5B3
   02-DEC-1997 ZE. -- merge VMSDEF into PYVMS
   03-JAN-1998 ZE. -- remove VMSMODULE - everything is in POSIXMODULE
   03-JAN-1998 ZE. -- add VMS_LNMDEF
   07-JAN-1998 ZE. -- add VMS_LBR
   27-APR-1998 ZE. -- remove 'reopmodule' - V1.5 -> V1.5.1
   06-SEP-1998 ZE. -- add VMS_UAIDEF
   24-NOV-1998 ZE. -- add VMS_PSCANDEF
   20-DEC-1998 ZE. -- add WITH_THREAD for tests
   12-JAN-1999 ZE. -- add VMS_DMTDEF
   13-JAN-1999 ZE. -- add VMS_MNTDEF
   22-JAN-1999 ZE. -- add VMS_INITDEF
   11-FEB-1999 ZE. -- add VMS_FABDEF, VMS_NAMDEF, VMS_RABDEF
   12-FEB-1999 ZE. -- add VMS_XABALLDEF, VMS_XABFHCDEF
   15-FEB-1999 ZE. -- add VMS_XABITMDEF
   23-FEB-1999 ZE. -- add VMS_XABKEYDEF
   08-MAR-1999 ZE. -- add VMS_XABPRODEF
   15-MAR-1999 ZE. -- add VMS_TRMDEF
   17-MAR-1999 ZE. -- add VMS_SJCDEF
*/

/* !!! !!! !!! This file is edited by the makesetup script !!! !!! !!! */
/* @@ not in OpenVMS port */

/* This file contains the table of built-in modules.
   See init_builtin() in import.c. */

#include "Python.h"


/* -- ADDMODULE MARKER 1 -- */

extern void PyMarshal_Init();
extern void initimp();

extern void initarray();
extern void initaudioop();
extern void initbinascii();
extern void initcmath();
extern void initcPickle();
extern void initcStringIO();
extern void initerrno();
#ifdef __VMS_POSIX
extern void initfcntl();
#endif
/* @- extern void initfpectl();  */
/* @- extern void initfpetest(); */
#ifndef __GNUC__
/* @@ extern void initgdbm(); */
#endif
extern void initimageop();
extern void initmath();
extern void initmd5();
extern void initnew();
extern void initoperator();
extern void initparser();
extern void initpcre();
extern void initposix();
#ifndef __VMS_POSIX
extern void initpyvms();
#endif
extern void initregex();
extern void initrgbimg();
extern void initrotor();
#if !defined(__GNUC__) || !defined(__VMS_POSIX)
extern void initselect();
#endif
extern void initsignal();
#ifndef __GNUC__
extern void initsocket();
#endif
extern void initsoundex();
extern void initstrop();
extern void initstruct();
#ifdef __VMS_POSIX
extern void inittermios();
#endif
extern void inittime();
extern void inittiming();
#ifdef WITH_THREAD
extern void initthread();
#endif
#ifndef __GNUC__
/* @@ extern void inittkinter(); */
#endif
#ifndef __VMS_POSIX
extern void initvms_dcdef();
extern void initvms_dmtdef();
extern void initvms_dvidef();
/* @@-- extern void initvms_dvsdef(); no vms_dvsdef.c */
extern void initvms_fabdef();
extern void initvms_fscndef();
extern void initvms_initdef();
extern void initvms_jpidef();
extern void initvms_kgbdef();
extern void initvms_lnmdef();
extern void initvms_mntdef();
extern void initvms_namdef();
/* @@-- extern void initvms_pqldef(); no vms_pqldef.c */
extern void initvms_prcdef();
extern void initvms_prvdef();
extern void initvms_pscandef();
extern void initvms_quidef();
extern void initvms_rabdef();
extern void initvms_sjcdef();
extern void initvms_statedef();
/* @@-- extern void initvms_syidef(); */
extern void initvms_trmdef();
extern void initvms_uaidef();
extern void initvms_xaballdef();
/* no       initvms_xabdatdef() exists */
extern void initvms_xabfhcdef();
extern void initvms_xabitmdef();
extern void initvms_xabkeydef();
extern void initvms_xabprodef();
/* no       initvms_xabrdtdef() exists */
extern void initvms_lbr();
extern void initvms_lib();
extern void initvms_sys();
#endif
#ifndef __GNUC__
/* @@ extern void initzlib(); */
#endif

/* @@ doesn't work:
struct {
	char *name;
	void (*initfunc)();
} inittab[] = {
*/
struct _inittab _PyImport_Inittab[] = {

	{"array",		initarray},
	{"audioop",		initaudioop},
	{"binascii",		initbinascii},
	{"cmath",		initcmath},
	{"cPickle",		initcPickle},
	{"cStringIO",		initcStringIO},
	{"errno",		initerrno},
#ifdef __VMS_POSIX
	{"fcntl",		initfcntl},
#endif
/* @-	{"fpectl",		initfpectl},  */
/* @-	{"fpetest",		initfpetest}, */
#ifndef __GNUC__
/* @@	{"gdbm",		initgdbm}, */
#endif
	{"imageop",		initimageop},
	{"math",		initmath},
	{"md5",			initmd5},
	{"new",			initnew},
	{"operator",		initoperator},
	{"parser",		initparser},
	{"pcre",		initpcre},
	{"posix",		initposix},
#ifndef __VMS_POSIX
	{"pyvms",		initpyvms},
#endif
	{"regex",		initregex},
	{"rgbimg",		initrgbimg},
	{"rotor",		initrotor},
#if !defined(__GNUC__) || !defined(__VMS_POSIX)
	{"select",		initselect},
#endif
#ifndef __GNUC__
	{"signal",		initsignal},
	{"socket",		initsocket},
#endif
	{"soundex",		initsoundex},
	{"strop",		initstrop},
	{"struct",		initstruct},
#ifdef __VMS_POSIX
	{"termios",		inittermios},
#endif
	{"time",		inittime},
	{"timing",		inittiming},
#ifdef WITH_THREAD
	{"thread",		initthread},
#endif
#ifndef __GNUC__
/* @@	{"tkinter",		inittkinter}, */
#endif
#ifndef __VMS_POSIX
	{"vms_dcdef",		initvms_dcdef},
	{"vms_dmtdef",		initvms_dmtdef},
	{"vms_dvidef",		initvms_dvidef},
/* --	{"vms_dvsdef",		initvms_dvsdef}, no vms_dvsdef.c */
	{"vms_fabdef",		initvms_fabdef},
	{"vms_fscndef",		initvms_fscndef},
	{"vms_initdef",		initvms_initdef},
	{"vms_jpidef",		initvms_jpidef},
	{"vms_kgbdef",		initvms_kgbdef},
	{"vms_lnmdef",		initvms_lnmdef},
	{"vms_mntdef",		initvms_mntdef},
	{"vms_namdef",		initvms_namdef},
/* --	{"vms_pqldef",		initvms_pqldef}, no vms_pqldef.c */
	{"vms_prcdef",		initvms_prcdef},
	{"vms_prvdef",		initvms_prvdef},
	{"vms_pscandef",	initvms_pscandef},
	{"vms_quidef",		initvms_quidef},
	{"vms_rabdef",		initvms_rabdef},
	{"vms_sjcdef",		initvms_sjcdef},
	{"vms_statedef",	initvms_statedef},
/* @@--	{"vms_syidef",		initvms_syidef}, */
	{"vms_trmdef",		initvms_trmdef},
	{"vms_uaidef",		initvms_uaidef},
	{"vms_xaballdef",	initvms_xaballdef},
/* no	{"vms_xabdatdef",	initvms_xabdatdef} exists ! */
	{"vms_xabfhcdef",	initvms_xabfhcdef},
	{"vms_xabitmdef",	initvms_xabitmdef},
	{"vms_xabkeydef",	initvms_xabkeydef},
	{"vms_xabprodef",	initvms_xabprodef},
/* no	{"vms_xabrdtdef",	initvms_xabrdtdef} exists ! */
	{"vms_lbr",		initvms_lbr},
	{"vms_lib",		initvms_lib},
	{"vms_sys",		initvms_sys},
#endif
#ifndef __GNUC__
/* @@	{"zlib",	initzlib}, */
#endif

/* -- ADDMODULE MARKER 2 -- */

	/* This module "lives in" with marshal.c */
	{"marshal", PyMarshal_Init},

	/* This lives it with import.c */
	{"imp", initimp},

	/* These entries are here for sys.builtin_module_names */
	{"__main__", NULL},
	{"__builtin__", NULL},
	{"sys", NULL},

	/* Sentinel */
	{0, 0}
};
