/* VMS_LIB_CVT_TOINTTIM.C -- 25-OCT-1998 Uwe Zessin
   Python interface to LIB$CVT_TO_INTERNAL_TIME

   doc string (vms_lib_cvt_tointtim__doc[]) in VMS_LIB.C
*/


#include "python.h"
#include "vmsdef.h"

#include <descrip.h>
#include <lib$routines.h>	/* LIB$name */
#include <libdef.h>		/* LIB$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_lib_gr_error;		/* exception vms_lib.error */
/* ------------------------------------------------------------------------- */

/* input a binary quadword - output a Python long integer */
extern PyObject * vms__cvt_quad2pylong (long q_quadword[2]);

/* ------------------------------------------------------------------------- */

PyObject *
vms_lib_cvt_to_internal_time (PyObject *self, PyObject *args)
{
	unsigned long		  l_operation;

	long		  	  l_input_time;

	PyObject		* ar_resultant_time;
	long			  q_resultant_time[2];

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "ll", &l_operation, &l_input_time))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1 - operation */

	/* -------------------- */
	/* argument 2 - input-time */

	/* -------------------- */
	l_status = lib$cvt_to_internal_time
		(&l_operation
		,&l_input_time
		,&q_resultant_time[0]
		);

	/* -------------------- */
	if (l_status == LIB$_NORMAL)
	{
	    return vms__cvt_quad2pylong (&q_resultant_time[0]);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_lib_gr_error, 1, l_status);
} /* vms_lib_cvt_to_internal_time () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_LIB_CVT_TOINTTIM.C */
